API reference

Payment Records

Knox answers these operations with the same requests and responses as Stripe's API. Authenticate with your secret key, Authorization: Bearer sk_test_..., from your server, and send form-encoded bodies. Test mode only: live processing is currently disabled.

List Payment Records

GET/v1/payment_records

List all the Payment Records for a given merchant.

Query parameters

  • created_afterinteger

    Only return Payment Records that were created after this unix timestamp.

  • created_beforeinteger

    Only return Payment Records that were created before this unix timestamp.

  • ending_beforestring

    A cursor for use in pagination. ending_before is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with obj_bar, your subsequent call can include ending_before=obj_bar in order to fetch the previous page of the list.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • limitinteger

    A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.

  • starting_afterstring

    A cursor for use in pagination. starting_after is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include starting_after=obj_foo in order to fetch the next page of the list.

Returns

A list of payment_record objects.

GET /v1/payment_records
curl -G https://api.knoxapi.com/v1/payment_records \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  --data-urlencode limit=3
Response
{
  "object": "list",
  "url": "/v1/payment_records",
  "has_more": false,
  "data": [
    {
      "amount": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_authorized": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_canceled": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_failed": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_guaranteed": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_refunded": {
        "currency": "usd",
        "value": 111972721
      },
      "amount_requested": {
        "currency": "usd",
        "value": 111972721
      },
      "application": null,
      "created": 1028554472,
      "customer_details": {
        "customer": null,
        "email": null,
        "name": null,
        "phone": null
      },
      "customer_presence": null,
      "description": null,
      "id": "obj_123",
      "latest_payment_attempt_record": null,
      "livemode": true,
      "metadata": {
        "key": "metadata"
      },
      "object": "payment_record",
      "payment_method_details": {
        "billing_details": {
          "address": {
            "city": null,
            "country": null,
            "line1": null,
            "line2": null,
            "postal_code": null,
            "state": null
          },
          "email": null,
          "name": null,
          "phone": null
        },
        "payment_method": null,
        "type": "type"
      },
      "processor_details": {
        "type": "custom"
      },
      "shipping_details": {
        "address": {
          "city": null,
          "country": null,
          "line1": null,
          "line2": null,
          "postal_code": null,
          "state": null
        },
        "name": null,
        "phone": null
      },
      "reported_by": "stripe"
    }
  ]
}

Report a payment

POST/v1/payment_records/report_payment

Report a new Payment Record. You may report a Payment Record as it is initialized and later report updates through the other report_* methods, or report Payment Records in a terminal state directly, through this method.

Body parameters

  • amount_requestedobjectRequired

    The amount you initially requested for this payment.

    Show 2 child parameters
    • currencystringRequired
    • valueintegerRequired
  • initiated_atintegerRequired

    When the reported payment was initiated. Measured in seconds since the Unix epoch.

  • payment_method_detailsobjectRequired

    Information about the Payment Method debited for this payment.

    Show 4 child parameters
    • billing_detailsobject
      Show 4 child parameters
      • addressobject

        Child parameters are listed in the OpenAPI document.

      • emailstring
      • namestring
      • phonestring
    • customobject
      Show 2 child parameters
      • display_namestring
      • typestring
    • payment_methodstring
    • typestring
      Possible values
      • custom
  • customer_detailsobject

    Customer information for this payment.

    Show 4 child parameters
    • customerstring
    • emailstring
    • namestring
    • phonestring
  • customer_presencestring

    Indicates whether the customer was present in your checkout flow during this payment.

    Possible values
    • off_session
    • on_session
  • descriptionstring

    An arbitrary string attached to the object. Often useful for displaying to users.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • failedobject

    Information about the payment attempt failure.

    Show 1 child parameter
    • failed_atintegerRequired
  • guaranteedobject

    Information about the payment attempt guarantee.

    Show 1 child parameter
    • guaranteed_atintegerRequired
  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

  • outcomestring

    The outcome of the reported payment.

    Possible values
    • failed
    • guaranteed
  • processor_detailsobject

    Processor information for this payment.

    Show 2 child parameters
    • typestringRequired
      Possible values
      • custom
    • customobject
      Show 1 child parameter
      • payment_referencestringRequired
  • shipping_detailsobject

    Shipping information for this payment.

    Show 3 child parameters
    • addressobject
      Show 6 child parameters
      • citystring
      • countrystring
      • line1string
      • line2string
      • postal_codestring
      • statestring
    • namestring
    • phonestring

Returns

The payment_record object.

POST /v1/payment_records/report_payment
curl https://api.knoxapi.com/v1/payment_records/report_payment \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d "amount_requested[currency]=usd" \
  -d "amount_requested[value]=111972721" \
  -d initiated_at=1 \
  -d payment_method_details=
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Retrieve a Payment Record

GET/v1/payment_records/{id}

Retrieves a Payment Record with the given ID

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Query parameters

  • expandarray of strings

    Specifies which fields in the response should be expanded.

Returns

The payment_record object.

GET /v1/payment_records/{id}
curl https://api.knoxapi.com/v1/payment_records/obj_123 \
  -H "Authorization: Bearer $KNOX_SECRET_KEY"
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report a payment attempt

POST/v1/payment_records/{id}/report_payment_attempt

Report a new payment attempt on the specified Payment Record. A new payment attempt can only be specified if all other payment attempts are canceled or failed.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • initiated_atintegerRequired

    When the reported payment was initiated. Measured in seconds since the Unix epoch.

  • descriptionstring

    An arbitrary string attached to the object. Often useful for displaying to users.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • failedobject

    Information about the payment attempt failure.

    Show 1 child parameter
    • failed_atintegerRequired
  • guaranteedobject

    Information about the payment attempt guarantee.

    Show 1 child parameter
    • guaranteed_atintegerRequired
  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

  • outcomestring

    The outcome of the reported payment.

    Possible values
    • failed
    • guaranteed
  • payment_method_detailsobject

    Information about the Payment Method debited for this payment.

    Show 4 child parameters
    • billing_detailsobject
      Show 4 child parameters
      • addressobject

        Child parameters are listed in the OpenAPI document.

      • emailstring
      • namestring
      • phonestring
    • customobject
      Show 2 child parameters
      • display_namestring
      • typestring
    • payment_methodstring
    • typestring
      Possible values
      • custom
  • shipping_detailsobject

    Shipping information for this payment.

    Show 3 child parameters
    • addressobject
      Show 6 child parameters
      • citystring
      • countrystring
      • line1string
      • line2string
      • postal_codestring
      • statestring
    • namestring
    • phonestring

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_payment_attempt
curl https://api.knoxapi.com/v1/payment_records/obj_123/report_payment_attempt \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d initiated_at=1
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report payment attempt canceled

POST/v1/payment_records/{id}/report_payment_attempt_canceled

Report that the most recent payment attempt on the specified Payment Record was canceled.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • canceled_atintegerRequired

    When the reported payment was canceled. Measured in seconds since the Unix epoch.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_payment_attempt_canceled
curl https://api.knoxapi.com/v1/payment_records/obj_123/report_payment_attempt_canceled \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d canceled_at=1
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report payment attempt failed

POST/v1/payment_records/{id}/report_payment_attempt_failed

Report that the most recent payment attempt on the specified Payment Record failed or errored.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • failed_atintegerRequired

    When the reported payment failed. Measured in seconds since the Unix epoch.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_payment_attempt_failed
curl https://api.knoxapi.com/v1/payment_records/obj_123/report_payment_attempt_failed \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d failed_at=1
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report payment attempt guaranteed

POST/v1/payment_records/{id}/report_payment_attempt_guaranteed

Report that the most recent payment attempt on the specified Payment Record was guaranteed.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • guaranteed_atintegerRequired

    When the reported payment was guaranteed. Measured in seconds since the Unix epoch.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_payment_attempt_guaranteed
curl https://api.knoxapi.com/v1/payment_records/obj_123/report_payment_attempt_guaranteed \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d guaranteed_at=1
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report payment attempt informational

POST/v1/payment_records/{id}/report_payment_attempt_informational

Report informational updates on the specified Payment Record.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • customer_detailsobject

    Customer information for this payment.

    Show 4 child parameters
    • customerstring
    • emailstring
    • namestring
    • phonestring
  • descriptionstring

    An arbitrary string attached to the object. Often useful for displaying to users.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

  • shipping_detailsobject

    Shipping information for this payment.

    Show 3 child parameters
    • addressobject
      Show 6 child parameters
      • citystring
      • countrystring
      • line1string
      • line2string
      • postal_codestring
      • statestring
    • namestring
    • phonestring

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_payment_attempt_informational
curl -X POST https://api.knoxapi.com/v1/payment_records/obj_123/report_payment_attempt_informational \
  -H "Authorization: Bearer $KNOX_SECRET_KEY"
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Report a refund

POST/v1/payment_records/{id}/report_refund

Report that the most recent payment attempt on the specified Payment Record was refunded.

Path parameters

  • idstringRequired

    The ID of the Payment Record.

Body parameters

  • outcomestringRequired

    The outcome of the reported refund.

    Possible values
    • refunded
  • processor_detailsobjectRequired

    Processor information for this refund.

    Show 2 child parameters
    • typestringRequired
      Possible values
      • custom
    • customobject
      Show 1 child parameter
      • refund_referencestringRequired
  • amountobject

    A positive integer in the smallest currency unit representing how much of this payment to refund. Can refund only up to the remaining, unrefunded amount of the payment.

    Show 2 child parameters
    • currencystringRequired
    • valueintegerRequired
  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • initiated_atinteger

    When the reported refund was initiated. Measured in seconds since the Unix epoch.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

  • refundedobject

    Information about the payment attempt refund.

    Show 1 child parameter
    • refunded_atintegerRequired

Returns

The payment_record object.

POST /v1/payment_records/{id}/report_refund
curl https://api.knoxapi.com/v1/payment_records/obj_123/report_refund \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d outcome=refunded \
  -d "processor_details[type]=custom"
Response
{
  "amount": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_authorized": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_canceled": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_failed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_guaranteed": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_refunded": {
    "currency": "usd",
    "value": 111972721
  },
  "amount_requested": {
    "currency": "usd",
    "value": 111972721
  },
  "application": null,
  "created": 1028554472,
  "customer_details": {
    "customer": null,
    "email": null,
    "name": null,
    "phone": null
  },
  "customer_presence": null,
  "description": null,
  "id": "obj_123",
  "latest_payment_attempt_record": null,
  "livemode": true,
  "metadata": {
    "key": "metadata"
  },
  "object": "payment_record",
  "payment_method_details": {
    "billing_details": {
      "address": {
        "city": null,
        "country": null,
        "line1": null,
        "line2": null,
        "postal_code": null,
        "state": null
      },
      "email": null,
      "name": null,
      "phone": null
    },
    "payment_method": null,
    "type": "type"
  },
  "processor_details": {
    "type": "custom"
  },
  "shipping_details": {
    "address": {
      "city": null,
      "country": null,
      "line1": null,
      "line2": null,
      "postal_code": null,
      "state": null
    },
    "name": null,
    "phone": null
  },
  "reported_by": "stripe"
}

Operations and schemas come from the pinned Stripe OpenAPI specification (MIT); response examples from its fixtures. Nested object definitions and enums are in the complete specification.